/////
// Lost 2.2
// A widget by Allen Wu/allewun
//
// No part of this widget (including images and code)
// may be used without explicit permission from me
// (Allen Wu - allewun@yahoo.com)
//
// 8/2/2006
/////

var prevMinutes = -1;
var prevSeconds = -1;
var playTickSound = false;
var flipSoundValue = preferences.flipSound.value;
var widgetLevel = mainWindow.level;

function initialize(){
	start = Math.floor((new Date()/1000)+(6485)); // 5 seconds extra, just to show 108 minutes
	textarea.editable = false;

	prevMinutes = -1;
	prevSeconds = -1;
	stopper = 1;
	onlyOnce = 1;

	mainTimer = new Timer();
	mainTimer.ticking = true;
	if(preferences.flipNumbers.value=="Yes"){
		mainTimer.interval = 0.1;
	}
	else if(preferences.flipNumbers.value=="No"){
		mainTimer.interval = 1;
	}
	mainTimer.onTimerFired = "countdown()";

	beepTimer = new Timer();
	beepTimer.ticking = false;
	beepTimer.interval = 2.5;
	beepTimer.onTimerFired = "beepSound()";

	alarmTimer = new Timer();
	alarmTimer.ticking = false;
	alarmTimer.interval = 2;
	alarmTimer.onTimerFired = "alarm()";

	blinkTimer = new Timer();
	blinkTimer.interval = 1;
	blinkTimer.onTimerFired = "blinking()";
	if((preferences.showBlinker.value=="Yes")&&(preferences.monitorSize.value==100)&&(textarea.editable==false)){blinkTimer.ticking = true;}
	else{blinkTimer.ticking = false;}

	preferences.flipSound.value = flipSoundValue;

	clockBase.src = "clockbase.png";
	black1.src = "black/13.png";
	black2.src = "black/03.png";
	black3.src = "black/83.png";
	white1.src = white2.src = "white/03.png";
}
initialize();

function beepSound(){
	play("sounds/beep.wav", false);
}
function alarm(){
	play("sounds/alarm.wav", false);
}

//////
// appendToFile() and escapeFilePath()
// Copyright 2005-2006 Harry Whitfield (g6auc)
/////

function escapeFilePath(path){
	return path.replace(/([\W])/g,'\\$1');
}

/*function appendToFile(path, contents){
	return runCommand("echo '" + contents + "' >> " + escapeFilePath(path));
}*/

function appendToFile(path, contents){
	if(preferences.logEntries.value==1){
		var data = filesystem.readFile(path);
		if(data==null){data="";}
		if(filesystem.readFile(path)==""){
			filesystem.writeFile(path, data+contents);
		}
		else if(filesystem.readFile(path)!=""){
			if(preferences.logFormat.value=="Broken"){
				filesystem.writeFile(path, data+"\n"+contents);
			}
			if(preferences.logFormat.value=="Continuous"){
				filesystem.writeFile(path, data+" "+contents);
			}
		}
	}
}

function stopCountdown(){
	if(stopper==1){play("sounds/ok.wav", false);}
	sleep(250);
	textarea.data="";
	blinker.hOffset = .9 * preferences.monitorSize.value;
	if(preferences.logEntries.value==1){
		var date = new Date();
		var month = (date.getMonth()+1).toString();
		if((month*1)<10){
			month = "0"+month;
		}
			var day = date.getDate().toString();
		if((day*1)<10){
			day = "0"+day;
		}
		var year = date.getFullYear().toString().substring(2);
		var hours = date.getHours().toString();
		if((hours*1)<10){
			hours = "0"+hours;
		}
		var minutes = date.getMinutes().toString();
		if((minutes*1)<10){
			minutes = "0"+minutes;
		}
		if(stopper==1){
			appendToFile(preferences.logFile.value,month+day+year+hours+":"+minutes+" accepted");
		}
		else if(stopper>1){
			appendToFile(preferences.logFile.value,month+day+year+hours+":"+minutes+" SYSTEM FAILURE SYSTEM FAILURE SYSTEM FAILURE SYSTEM FAILURE SYSTEM FAILURE SYSTEM FAILURE SYSTEM FAILURE SYSTEM FAILURE");
		}	
	}
	mainTimer.ticking = false;
	start = null;

	beepTimer.ticking = false;
	alarmTimer.ticking = false;
	alarmTimer.interval = 2;

	play("sounds/reset.wav", false);
	resetNumbers("regular");

	if(preferences.autoPopup.value==1){
		mainWindow.level = clockWindow.level = executeWindow.level = widgetLevel;
	}

	initialize();
	countdown();
}

function resetNumbers(x){
	if(x=="regular"){
		for(i=0;i<5;i++){
			black1.src = black2.src = black3.src = "black/blur1.png";
			white1.src = white2.src = "white/blur1.png";
			sleep(1);
			black1.src = black2.src = black3.src = "black/blur2.png";
			white1.src = white2.src = "white/blur2.png";
			sleep(1);
			black1.src = black2.src = black3.src = "black/blur3.png";
			white1.src = white2.src = "white/blur3.png";
			sleep(1);
			black1.src = black2.src = black3.src = "black/blur4.png";
			white1.src = white2.src = "white/blur4.png";
			sleep(1);
			black1.src = black2.src = black3.src = "black/blur5.png";
			white1.src = white2.src = "white/blur5.png";
			sleep(1);
			black1.src = black2.src = black3.src = "black/blur6.png";
			white1.src = white2.src = "white/blur6.png";
			sleep(1);
			black1.src = black2.src = black3.src = "black/blur7.png";
			white1.src = white2.src = "white/blur7.png";
			sleep(1);
		}
	}
	if(x=="hieroglyphics"){
		for(i=0;i<13;i++){
			black1.src = black2.src = black3.src = "glyphs/blur1.png";
			white1.src = white2.src = "glyphs/blur4.png";
			sleep(1);
			black1.src = black2.src = black3.src = "glyphs/blur2.png";
			white1.src = white2.src = "glyphs/blur5.png";
			sleep(1);
			black1.src = black2.src = black3.src = "glyphs/blur3.png";
			white1.src = white2.src = "glyphs/blur4.png";
			sleep(1);
			black1.src = black2.src = black3.src = "glyphs/blur1.png";
			white1.src = white2.src = "glyphs/blur5.png";
			sleep(1);
			black1.src = black2.src = black3.src = "glyphs/blur2.png";
			white1.src = white2.src = "glyphs/blur4.png";
		}
	}
}

var clock1Black = [];
for(i=0; i<10; i++){
	clock1Black[i] = "black/" + i + "1.png";
}
var clock2Black = [];
for(i=0; i<10; i++){
	clock2Black[i] = "black/" + i + "2.png";
}
var clock3Black = [];
for(i=0; i<10; i++){
	clock3Black[i] = "black/" + i + "3.png";
}

var clock1White = [];
for(i=0; i<10; i++){
	clock1White[i] = "white/" + i + "1.png";
}
var clock2White = [];
for(i=0; i<10; i++){
	clock2White[i] = "white/" + i + "2.png";
}
var clock3White = [];
for(i=0; i<10; i++){
	clock3White[i] = "white/" + i + "3.png";
}

// updateDigit() function borrowed from flipCount 1.1.1 widget (by Eric St. Onge)
// modification by William Warby
function updateDigit(digitObject, currentDigit, animationFrame){
	if(playTickSound == true){
		play("sounds/flip.wav", false);
		playTickSound = false; //only play once
	}
	digitColor = (digitObject.name.toLowerCase().indexOf("white") != -1) ? "White" : "Black";
	if((preferences.flipNumbers.value=="Yes")&&(minutes.indexOf('-')==-1)){
		if(digitObject.src.indexOf(eval("clock3" + digitColor + "[" + currentDigit + "]"))<0 && animationFrame<4){
			digitObject.src = eval("clock" + (animationFrame) + digitColor + "[" + currentDigit + "]");
			animationFrame++;
		}
		else{
			digitObject.src = eval("clock3" + digitColor + "[" + currentDigit + "]");
			animationFrame=1;
		}
		return animationFrame;
	}
	else if(preferences.flipNumbers.value=="No"){
		digitObject.src = eval("clock3" + digitColor + "[" + currentDigit + "]");
		animationFrame=1;
		return animationFrame;
	}
}

counterM = 1;
counterMM = 1;
counterMMM = 1;
counterS = 1;
counterSS = 1;

function countdown(){
	current = new Date()/1000;
	minutes = (Math.floor((start - current)/60)).toString();
	seconds = (Math.floor((start - current)%60)).toString();

	if((minutes*1)<100){
		minutes = "0"+minutes;
		if((minutes*1)<10){
			minutes = "0"+minutes;
		}
	}
	if((seconds*1)<10){
		seconds = "0"+seconds;
	}

	minHundred = minutes.substring(0,1);
	minTen = minutes.substring(1,2);
	minOne = minutes.substring(2,3);

	secTen = seconds.substring(0,1);
	secOne = seconds.substring(1,2);

	counterM = updateDigit(black1, minHundred, counterM);
	counterMM = updateDigit(black2, minTen, counterMM);
	counterMMM = updateDigit(black3, minOne, counterMMM);

	if(preferences.flipSound.value=="Yes"){
		if((minutes != prevMinutes)&&(minutes != "108")){
			prevMinutes = minutes;
			playTickSound = true;
		}
	}

	if(((minutes*1)<=3)&&(minutes>0)){
		beepTimer.ticking = true;
		alarmTimer.ticking = false;
		blinkTimer.ticking = false;
		textarea.editable = true;

		counterS = updateDigit(white1, secTen, counterS);
		counterSS = updateDigit(white2, secOne, counterSS);

		if(system.platform.toLowerCase()=="macintosh"){
			if(preferences.flipSound.value=="Yes"){
				if(minutes != prevMinutes){
					prevMinutes = minutes;
					playTickSound = true;
				}
				if(seconds != prevSeconds){
					prevSeconds = seconds;
					playTickSound = true;
				}
			}
		}
		else if(system.platform.toLowerCase()=="windows"){
			if((preferences.flipSound.value=="Yes")&&(preferences.overlapSounds.value==0)){
				if(minutes != prevMinutes){
					prevMinutes = minutes;
					playTickSound = true;
				}
				if(seconds != prevSeconds){
					prevSeconds = seconds;
					playTickSound = true;
				}
			}
		}
		if(preferences.autoPopup.value==1){
			if(onlyOnce==1){
				mainWindow.level = clockWindow.level = executeWindow.level = "topMost";
				mainWindow.focus();
				textarea.focus();
				onlyOnce++;
			}
		}
	}

	if((minutes*1)==0){
		beepTimer.ticking = false;
		alarmTimer.ticking = true;
		textarea.editable = true;

		counterS = updateDigit(white1, secTen, counterS);
		counterSS = updateDigit(white2, secOne, counterSS);
		if((seconds*1)<=10){
			alarmTimer.interval = 1;
		}
	}

	if((minutes.indexOf('-')!=-1) || (seconds.indexOf('-')!=-1)){
		beepTimer.ticking = false;
		alarmTimer.ticking = false;
		textarea.editable = true;
		if(stopper==1){
			play("sounds/reset.wav", false);
			resetNumbers("hieroglyphics");
			black1.src = "glyphs/glyph1.png";
			black2.src = "glyphs/glyph2.png";
			black3.src = "glyphs/glyph3.png";
			white1.src = "glyphs/glyph4.png";
			white2.src = "glyphs/glyph5.png";
			sleep(2000);
			stopper++;
		}
		if((stopper>1)&&(stopper<6)){
			play("sounds/systemfailure.wav", false);
			sleep(2250);
			stopper++;
		}
		if((stopper>5)&&(stopper<15)){
			play("sounds/electro.wav", false); //slight delay between each loop, nothing i can do
			sleep(750);
			stopper++;
		}
		if(stopper==15){
			var Xdate = new Date();
			var Xmonth = (Xdate.getMonth()+1).toString();
			if((Xmonth*1)<10){
				Xmonth = "0"+Xmonth;
			}
			var Xday = Xdate.getDate().toString();
			if((Xday*1)<10){
				Xday = "0"+Xday;
			}
			var Xyear = Xdate.getFullYear().toString().substring(2);
			var Xhours = Xdate.getHours().toString();
			if((Xhours*1)<10){
				Xhours = "0"+Xhours;
			}
			var Xminutes = Xdate.getMinutes().toString();
			if((Xminutes*1)<10){
				Xminutes = "0"+Xminutes;
			}
			appendToFile(preferences.logFile.value, Xmonth+Xday+Xyear+Xhours+":"+Xminutes+" SYSTEM FAILURE SYSTEM FAILURE SYSTEM FAILURE SYSTEM FAILURE SYSTEM FAILURE SYSTEM FAILURE SYSTEM FAILURE SYSTEM FAILURE");
			textarea.editable = false;
			clockWindow.width = clockBase.width = 255 * (preferences.clockSize.value / 100);
			clockWindow.height = clockBase.height = 132 * (preferences.clockSize.value / 100);
			clockBase.src = "destroyed.png";
			black1.src = black2.src = black3.src = white1.src = white2.src = "";
			play("sounds/crush.wav", false);
			sleep(3000);
			if(preferences.autoPopup.value==1){
				mainWindow.level = clockWindow.level = executeWindow.level = widgetLevel;
			}
			if((preferences.endAgree.value==0)||(preferences.endType.value=="Nothing")){
				closeWidget();
			}
			else if(preferences.endAgree.value==1){
				if(system.platform == "macintosh"){
					switch(preferences.endType.value){
						case "Standby":
							cmd = "osascript -e 'tell application \"System Events\" to sleep'";
							break;
						case "Shutdown":
							cmd = "osascript -e 'tell application \"System Events\" to shut down'";
							break;
						case "Restart":
							cmd = "osascript -e 'tell application \"System Events\" to restart'";
							break;
						default:
							break;
					}
				}
				else if(system.platform == "windows"){
					switch(preferences.endType.value){
						case "Standby":
							cmd = "rundll32.exe PowrProf.dll,SetSuspendState";
							break;
						case "Shutdown":
							cmd = "cscript.exe Shutdown.vbs";
							break;
						case "Restart":
							cmd = "cscript.exe Restart.vbs";
							break;
						default:
							break;
					}
				}
				runCommand(cmd);
				initialize();
				applyPrefs();
			}
		}
		if(stopper==16){
			closeWidget();
		}
		
	}

	if(preferences.flipNumbers.value=="Yes"){
		mainTimer.interval = 0.1;
	}
	else if(preferences.flipNumbers.value=="No"){
		mainTimer.interval = 1;
	}
}
countdown();

function applyPrefs(){
	var mSize = preferences.monitorSize.value / 100; //Monitor size
	var cSize = preferences.clockSize.value / 100; //Clock size

	mainWindow.width = 510 * mSize;
	mainWindow.height = 330 * mSize;

	monitor.src = "original.png";
	monitor.width = 510 * mSize;
	monitor.height = 330 * mSize;

	prompt.hOffset = 70 * mSize;
	prompt.vOffset = 65 * mSize;
	prompt.size = 15 * mSize;

	textarea.width = 250 * mSize;
	textarea.hOffset = 85 * mSize;
	textarea.vOffset = 53 * mSize;
	textarea.size = 12 * mSize;

	clockWindow.width = 233 * cSize;
	clockWindow.height = 114 * cSize;

	clockBase.width = 233 * cSize;
	clockBase.height = 114 * cSize;

	black1.width = 40 * cSize;
	black1.height = 50 * cSize;
	black1.hOffset = 14 * cSize;
	black1.vOffset = black2.vOffset = black3.vOffset = 24 * cSize;

	black2.width = 40 * cSize;
	black2.height = 50 * cSize;
	black2.hOffset = 54 * cSize;

	black3.width = 40 * cSize;
	black3.height = 50 * cSize;
	black3.hOffset = 94 * cSize;

	white1.width = 40 * cSize;
	white1.height = 50 * cSize;
	white1.hOffset = 142 * cSize;
	white1.vOffset = white2.vOffset = 24 * cSize;

	white2.width = 40 * cSize;
	white2.height = 50 * cSize;
	white2.hOffset = 182 * cSize;

	if((preferences.monitorSize.value==100)&&(preferences.showBlinker.value=="Yes")){
		blinker.width = 8 * mSize;
		blinker.height = 16 * mSize;
		blinker.hOffset = 90 * mSize;
		blinker.vOffset = 52 * mSize;
		blinker.visible = true;
		blinkTimer.ticking = true;
	}
	else{
		blinker.visible = false;
		blinkTimer.ticking = false;
	}
}
applyPrefs();

function showExecute(){
	if(preferences.showExecute.value == "Yes"){
		executeWindow.visible = true;
	}
	else if(preferences.showExecute.value == "No"){
		executeWindow.visible = false;
	}
}
showExecute();

function openLog(){
	var log = preferences.logFile.value;
	if(log!=""){
		if(filesystem.itemExists(log)){
			filesystem.open(log);
		}
		else{
			alert(log+"\nThe log file doesn't exist.");
		}
	}
	else{
		alert("No log file specified.");
	}
}

function confirmEnding(){
	if((preferences.endType.value!="Nothing")&&(preferences.endAgree.value==1)){
		var answer = alert("You have enabled your computer to " + preferences.endType.value + " after the countdown ends. Is this ok?", "Yes", "No");
		if(answer==1){
			preferences.endAgree.value=1;
		}
		else{
			preferences.endAgree.value=0;
		}
	}
}

function blinkingCursor(){
	var keyString = system.event.keyString;
	var x = blinker.hOffset;
	var x2 = .9 * preferences.monitorSize.value;
	var x3 = x2 + (245);

	if("Backspace".indexOf(keyString)!=-1){
		if(x>x2){
			blinker.hOffset = x-7;
		}
	}
	else if("EscapeTabDelete".indexOf(keyString)!=-1){
		textarea.rejectKeyPress();
	}
	else if("EnterReturn".indexOf(keyString)==-1){
		if(x<x3){
			blinker.hOffset = x+7;
		}
	}
}

function blinking(){
if(textarea.editable==false){
	if(blinker.visible==true){
		blinker.visible = false;
	}
	else{
		blinker.visible = true;
	}
}
}